<?php

class Merc_EnforcePostRules_Listener
{
	public static function loadClassDataWriter($class, array $extend)
	{
		if ($class == 'XenForo_DataWriter_Forum')
			$extend[] = 'Merc_EnforcePostRules_DataWriter_Forum';
	}

	public static function loadClassController($class, array &$extend)
	{
		if ($class == 'XenForo_ControllerAdmin_Forum')
			$extend[] = 'Merc_EnforcePostRules_ControllerAdmin_Forum';
		else if ($class == 'XenForo_ControllerPublic_Forum')
			$extend[] = 'Merc_EnforcePostRules_ControllerPublic_Forum';
	}

	public static function templatePostRender($templateName, &$content, array &$containerData, XenForo_Template_Abstract $template)
	{
		if ($templateName == 'thread_create')
		{
			$forum = $template->getParam('forum');
			if ($forum['require_post_rules'])
			{
				$link = XenForo_Link::buildPublicLink('forums/add-thread', $forum);
				$content = str_replace(
					'<form action="' . $link . '"',
					'<form action="' . $link . '" id="ctrl_agree_Disabler"',
					$content
				);
			}
		}
	}

	public static function templateHook($hookName, &$contents, array $hookParams, XenForo_Template_Abstract $template)
	{
		if (method_exists(__CLASS__, '_' . $hookName))
		{
			$method = '_' . $hookName;
			$contents = self::$method($contents, $template);
		}
	}

	protected static function _admin_forum_edit_forum_options($contents, XenForo_Template_Abstract $template)
	{
		return $contents . $template->create('merc_post_rules_forum_options', $template->getParams());
	}

	protected static function _thread_create($contents, XenForo_Template_Abstract $template)
	{
		$forum = $template->getParam('forum');
		if ($forum['require_post_rules'])
		{
			$pos = strpos($contents, '<!-- slot: after_editor -->') + 27;
			$newContent = $template->create('merc_thread_create_post_rules', array('url' => $forum['post_rules_url'], 'overlay' => $forum['post_rules_overlay']));
			$contents = substr($contents, 0, $pos) . $newContent . substr($contents, $pos);
		}

		return $contents;
	}

	protected static function _page_container_head($contents, XenForo_Template_Abstract $template)
	{
		if ($template->getParam('controllerName') == 'XenForo_ControllerPublic_Forum' && $template->getParam('controllerAction') == 'CreateThread')
		{
			$contents .= $template->create('merc_thread_create_post_rules_js');
		}

		return $contents;
	}
}